<?php 

// look for system modal message
	$system_modal_message = '';
	$system_modal = '0';

	if(Session::has('system_modal.message')){
		$system_modal = '1';
		$system_modal_message = Session::get('system_modal.message');
	}
?>
@extends('app')

@section('system_active', 'class="active"')

@section('content')
<input name="firmware_id" id="firmware_id" type="hidden" value="">
<input name="filename" id="filename" type="hidden" value="">
<input name="selected" id="selected" type="hidden" value="">
<input name="scroll_to_top" id="scroll_to_top" type="hidden" value="0">
<h3><i class='fa fa-{{ $product_feature->glyph_name }}'></i>&nbsp;&nbsp;{{ $product_feature->label_plural }} &nbsp;&nbsp;<a href="/system" type="button" name="doneButton" id="doneButton" class="btn btn-primary">Done</a>&nbsp;&nbsp;<a href="/help/topics/#t=<?php echo $topicurl; ?>" target="_blank" class="btn btn-primary" role="button"><i class='fa fa-lg fa-question-circle'></i></a> &nbsp;&nbsp;<font size="4">Version <?php echo $version; ?></font></h3>
@can('edit_system_update')<button type="button" style="margin-bottom:10px; margin-right:10px;min-width:150px;" name="uploadButton" id="uploadButton" class="btn btn-primary" onclick="system_update_button()"><i class='fa fa-upload'></i> Upload</button><button type="button" style="margin-bottom:10px; margin-right:10px;min-width:150px;" name="updatesButton" id="updatesButton" class="btn btn-primary" onclick="updatesButton()"><i class='fa fa-download'></i> Check For System Updates</button> <button type="button" name="ssuButton" id="ssuButton" style="margin-bottom:10px; margin-right:10px;min-width:150px;" onClick="ssu_button();" class="btn btn-primary"><i class='fa fa-cog'></i> Configure Automatic Software Download</button> @endcan 
<div class="row">
        <div class="col-md-8">
          <table id="update_table" class ="table table-striped">
            <thead>
              <tr>
               <th class="text-nowrap" data-align="center" data-width="50">Actions</th>
                <th class="text-nowrap" data-align="center" data-sortable="true">Filename</th>
            </thead>
            <tbody>
            @foreach ($files as $key => $file)
              <tr>
               <td class="text-nowrap" data-align="center"><div class="button-container">
				 @can('edit_system_update')<a href="javascript:void(0)" onClick="showReleaseNotesBeforeUpdate('{{ $file }}');" class="btn btn-xs btn-success" role="button" data-toggle="tooltip" title="Run Update"> <i class='fa fa-chevron-circle-right'></i>&nbsp;</a> @endcan
				 <a href="javascript:void(0)" onClick="viewReleaseNotes('{{ $file }}');" class="btn btn-xs btn-primary" role="button" data-toggle="tooltip" title="View Release Notes">&nbsp;<i class='fa fa-info'></i>&nbsp;</a> 
                
					@can('delete_system_update')<a type="button" onclick="deleteModal('modal{!! $key !!}');" class="btn btn-xs btn-danger" data-toggle="tooltip" title="Delete"><i class='fa fa-trash-o'></i></a>@endcan
					<!--  modal -->
					<div class="modal bs-example-modal-sm modal{!! $key  !!}" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" data-backdrop="static" data-keyboard="false">
 						<div class="modal-dialog">
   						<div class="modal-content">
   							 <div class="modal-header">
       							<h4 class="modal-title"><p align="center">{{ $product_feature->label }}</p></h4>
     							</div>
     							<div class="modal-body">
									Are you sure you want to delete {{ $file  }} ?
     							</div>
     							<div class="modal-footer">
       							<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
       							<button type="button" class="btn btn-danger" data-dismiss="modal" onClick="delete_system_update('{!! $file !!}');">Delete</button>
     							</div>
   						</div>
 						</div>						
                       </div>
                       <!--  end modal -->
                        </div>
                        </td>
                <td class="text-nowrap" data-align="center">{{ $file }} </td>
              </tr>
              @endforeach
            </tbody>
          </table>
        </div>
        </div> 
<!--  start system update import modal -->
<div class="modal bs-example-modal-sm modal-system-update-import" id="modal-system-update-import" tabindex="-1" role="dialog" aria-labelledby="modal-system-update-import" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog">
    <div class="modal-content">
             <div class="modal-header">       							
            <h4 class="modal-title"><p align="center">Upload</p></h4>
            </div>
            <form method="POST" action="/system/import_update" class="form-horizontal" enctype="multipart/form-data">
            <input type="hidden" name="_token" value="{{ csrf_token() }}">

            <div align="center" class="modal-body">

                <div style="text-align:center; width:60%;">
                    <input id="fileupload" name="fileupload" type="file" class="filestyle" data-buttonName="btn-primary" data-buttonText="&nbsp;Choose file" data-size="sm" data-placeholder="No file selected">
                </div>

            </div>
            <div class="modal-footer">        							
            <button type="button" name="importCloseButton" id="importCloseButton" class="btn btn-default" data-dismiss="modal">Close</button>
            <button  type="submit" name="importButtonModal" id="importButtonModal" onClick="forms[0].submit();" class="btn btn-primary"><i class='fa fa-upload'></i> Upload</button>
            </div>
          </form>
    </div>  							
    </div>
    </div>
<!--  end system update import modal -->
	 
<!--start release notes modal -->
 <div id="releaseNotesModal" class="modal bs-example-modal-sm" tabindex="-1" role="dialog" aria-labelledby="releaseNotesModal" data-backdrop="static" data-keyboard="false">
  <div class="modal-dialog">
    <div class="modal-content">
    	<div class="modal-header">
                    <h4 class="modal-title"><p align="center"><p align="center">Release Notes</p></p></h4>
                </div>
	  	<input type="hidden" name="firmware_filename" id="firmware_filename" value="">
        <div class="modal-body">
			<p align="left" id="c4000_text" style="overflow: scroll; height:400px;"><strong id="release_notes_text"><strong></p>
        </div>
        <div class="modal-footer">
			<button type="button" class="btn btn-primary" data-dismiss="modal">Ok</button>
        </div>
  </div>
</div>
</div>
 <!--end release notes Modal -->
	 
<!--start release notes before running udpate modal -->
 <div id="releaseNotesBeforeUpdateModal" class="modal bs-example-modal-sm" tabindex="-1" role="dialog" aria-labelledby="releaseNotesBeforeUpdateModal" data-backdrop="static" data-keyboard="false">
  <div class="modal-dialog">
    <div class="modal-content">
    	<div class="modal-header">
                    <h4 class="modal-title"><p align="center"><p align="center">Release Notes</p></p></h4>
                </div>
	  	<input type="hidden" name="filename_before_update" id="filename_before_update" value="">
        <div class="modal-body">
			<p align="left" id="c4000_text" style="overflow: scroll; height:400px;"><strong id="release_notes_before_update_text"><strong></p>
        </div>
        <div class="modal-footer">
			<button type="button" name="cancelUpdateButton" id="cancelUpdateButton" class="btn btn-default" data-dismiss="modal">Cancel Update</button>
            <button  type="button" name="startUpdateButton" id="startUpdateButton" onClick="run_system_update();" class="btn btn-success"><i class='fa fa-chevron-circle-right'></i> Start Update</button>
        </div>
  </div>
</div>
</div>
 <!--end release notes before running udpate Modal -->
	 
<!--start updates modal -->
 <div id="updatesModal" class="modal bs-example-modal-sm" tabindex="-1" role="dialog" aria-labelledby="updatesModal" data-backdrop="static" data-keyboard="false">
  <div class="modal-dialog">
    <div class="modal-content">
    	<div class="modal-header">
                    <h4 class="modal-title"><p align="center"><p align="center">Check For System Updates</p></p></h4>
                </div>
        <div class="modal-body">
			<p id="updates_text" align="center"></p>
        </div>
        <div class="modal-footer">
			<button id="okButton" type="button" class="btn btn-primary" data-dismiss="modal" onClick="reloadList();">Ok</button>
        </div>
  </div>
</div>
</div>
 <!--end updates Modal -->
<!--  start system update modal -->
<div class="modal bs-example-modal-sm system-update-modal" id="system-update-modal" tabindex="-1" role="dialog" aria-labelledby="system-update-modal" data-backdrop="static" data-keyboard="false">
	<div class="modal-dialog">
	<div class="modal-content">
			 <div class="modal-header">       							
			<h4 class="modal-title"><p align="center">Upload</p></h4>
			</div>
			<div align="center" class="modal-body">
				<div id="system_update_text" style="text-align:center; width:60%;">
				<?php echo $system_modal_message;?>
				</div>
			</div>
			<div class="modal-footer">        							
			<button type="button" class="btn btn-default" data-dismiss="modal">Ok</button>
			</div>
	</div>  							
	</div>
	</div>
<!--  end system update modal -->

<!--start runUpdate modal -->
 <div id="runUpdateModal" class="modal bs-example-modal-sm" tabindex="-1" role="dialog" aria-labelledby="runUpdateModal" data-backdrop="static" data-keyboard="false">
  <div class="modal-dialog">
    <div class="modal-content">
    	<div class="modal-header">
                    <h4 class="modal-title"><p align="center"><p align="center">Run System Update</p></p></h4>
                </div>
        <div class="modal-body">
			<p id="run_update_text" align="center"></p>
        </div>
        <div class="modal-footer">
			<button id="okButton2" type="button" class="btn btn-primary" data-dismiss="modal" onClick="reloadList();">Ok</button>
        </div>
  </div>
</div>
</div>
 <!--end runUpdate Modal -->
@stop

@section('title')
	{{ $product_feature->label_plural }}

@stop

@section('footer')
	
<script>

var duration = (60 * 5)-1;
var timer = duration;
var minutes;
var seconds;
var timerInterval;
	
 $(document).ready(function() { 

	 // check for system modal
	 var system_modal = '<?php echo $system_modal;?>';

	 if(system_modal=='1'){
		 $('.system-update-modal').modal('show');
	 }
});
 // calculate the table height
 var document_height = window.innerHeight;
 var table_height = parseInt(document_height*0.7);
 var version_timer;
	
// Flash message
$('div.alert').delay(3000).slideUp(300);
// tool tip 
$(function () {
  $('[data-toggle="tooltip"]').tooltip()
}).on('show.bs.tooltip', function () {
		var table_object = $('#firmware_table').bootstrapTable('getOptions');
	    var cardView = table_object.cardView;
		var scroll_to_top = document.getElementById("scroll_to_top").value;
		if(cardView==false && scroll_to_top==1){ // only scroll if in list view
			$('#firmware_table').bootstrapTable('scrollTo','0');
		}
		document.getElementById("scroll_to_top").value = 0;
});
// bootstrap-table settings
$('#update_table').bootstrapTable({
    search: true,
	height: table_height,
	striped: false,
	classes: 'table',
	showToggle: true,
	trimOnSearch: false,
}).on('sort.bs.table', function (e, name, order) {
	
	var isMobile = navigator.userAgent.match(/(iPhone|iPad|Android)/);
	if(isMobile){
		setTimeout(function(){
			$('.tooltip').hide(); // hide tooltip when sorting											
		}, 3000);
	} else {
		$('.tooltip').hide(); // hide tooltip when sorting	
	}
}).on('all.bs.table', function (e, name, order) {
	tooltipExe() // reactivates tooltips after sorting or switching to cardview
}).on('click-row.bs.table', function (e, row, $element) { // change row color to blue on click
    		$('.info').removeClass('info');
    		$($element).addClass('info');
});

function tooltipExe(){
	$('[data-toggle="tooltip"]').tooltip()
};
function uploadButton() {
	$('#uploadModal').modal('show');
}
function scrollToTop(){
	document.getElementById("scroll_to_top").value = 1;
}
function deleteModal(modal_name){
	$('.'+modal_name).modal('show');
}
function updatesButton(){
	
	document.getElementById("updates_text").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> Checking for Nyquist System Software updates'; 
	document.getElementById('okButton').style.visibility='hidden';
	$('#updatesModal').modal('show');
	
	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			//console.log(response);
			if(response=='0'){
				document.getElementById("updates_text").innerHTML = 'No Nyquist System Software updates available.';
				document.getElementById('okButton').style.visibility='visible';
			} else if(response=='-1'){
			   	document.getElementById("updates_text").innerHTML = 'Can\'t check for system updates, check Internet connection and try again.';
				document.getElementById('okButton').style.visibility='visible';
			} else if(response=='1'){
			   document.getElementById("updates_text").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> Downloading Nyquist System Software Update ...';
				download_system_updates();
			} else {
				$('#updatesModal').modal('hide');
			}
		}
	}
	xmlhttp.open("GET","/system/check_for_updates/",true);
	xmlhttp.send();	
	
}
function download_system_updates(){
	
	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			//console.log(response);
			if(response=='0'){
				document.getElementById("updates_text").innerHTML = 'Nyquist System Software download failed, try again.'; 
				document.getElementById('okButton').style.visibility='visible';
			} else if(response=='1'){
				document.getElementById("updates_text").innerHTML = 'Nyquist System Software download successful.';
				document.getElementById('okButton').style.visibility='visible'; 
			} else {
				$('#updatesModal').modal('hide');	  
			}
		}
	}
	xmlhttp.open("GET","/system/download_system_updates",true);
	xmlhttp.send();	
	
}
function reloadList(){
	window.location.href = '/system/system_update';	
}
function viewReleaseNotes(filename){
	
	var version = filename.replace("NyqUpdate-", "");
	version = version.replace(".tar.gz", "");
		
	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			// console.log(response);
			if(response!='' && response!='999'){
				document.getElementById("release_notes_text").innerHTML = response;
			   	$('#releaseNotesModal').modal('show');
			} else {
				document.getElementById("release_notes_text").innerHTML = 'Release notes not available for selected version.';
			   	$('#releaseNotesModal').modal('show');
			}
		}
	}
	xmlhttp.open("GET","/system/view_release_notes/"+version,true);
	xmlhttp.send();	
		
}
function showReleaseNotesBeforeUpdate(filename){
	
	document.getElementById("filename_before_update").value = filename;
	
	var version = filename.replace("NyqUpdate-", "");
	version = version.replace(".tar.gz", "");
		
	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			// console.log(response);
			if(response!='' && response!='999'){
				document.getElementById("release_notes_before_update_text").innerHTML = response;
			   	$('#releaseNotesBeforeUpdateModal').modal('show');
			} else {
				document.getElementById("release_notes_before_update_text").innerHTML = 'Release notes not available for selected version.';
			   	$('#releaseNotesBeforeUpdateModal').modal('show');
			}
		}
	}
	xmlhttp.open("GET","/system/view_release_notes/"+version,true);
	xmlhttp.send();	
		
}
function ssu_button(){
	 window.location.href = '/ssu/1/edit';
}
// system update button
function system_update_button() {	
	$('.modal-system-update-import').modal('show');
}
function delete_system_update(filename){
	
	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			//console.log(response);
			
			window.location.href = '/system/system_update';
		}
	}
	xmlhttp.open("GET","/system/delete_system_update/"+filename,true);
	xmlhttp.send();	
	
}
function run_system_update(){
	
	var filename_before_update =  document.getElementById("filename_before_update").value;
	
	document.getElementById("run_update_text").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> Running Nyquist System Software update ...<br><br><div class="alert alert-warning" role="alert"><strong><i class="fa fa-warning margin-bottom"></i>&nbsp;&nbsp;DO NOT CLOSE THIS PAGE OR CLICK ANYTHING UNTIL DONE.<br><br>A new message will appear when the update is complete.</strong></div>'; 
	
	document.getElementById('okButton2').style.visibility='hidden';
	
	$('#releaseNotesBeforeUpdateModal').modal('hide');
	
	$('#runUpdateModal').modal('show');

	// ajax action to call api so screen does not refresh
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
			// success 
			var response = xmlhttp.responseText.trim();
			//console.log(response);
			if(response=='1'){
				document.getElementById("run_update_text").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> The Nyquist system update is finished and the<br>Nyquist web server is now being updated.<br><br><div class="alert alert-warning" role="alert"><strong><i class="fa fa-warning margin-bottom"></i>&nbsp;&nbsp;DO NOT CLOSE THIS PAGE OR CLICK ANYTHING UNTIL DONE.<br><br>A new message and OK button will appear when the timer is complete.<br><br><span id="timer_text">05:00</span></strong></div>';
				 startTimer();
			} else if(response=='3'){
				document.getElementById("run_update_text").innerHTML = '<i class="fa fa-exclamation-triangle"></i> You can not run a system update from the Master IP Address when Automatic Failover is active. Log in to the server via the Primary Server IP Address (<?php echo $master_ip;?>) to perform the system update.';
				document.getElementById('okButton2').style.visibility='visible';
			} else if(response=='4'){
				document.getElementById("run_update_text").innerHTML = '<i class="fa fa-exclamation-triangle"></i> You can not run a system update from the Master IP Address when Automatic Failover is active. Log in to the server via the Secondary Server IP Address (<?php echo $standby_ip;?>) to perform the system update.';
				document.getElementById('okButton2').style.visibility='visible';
			} else {
				document.getElementById("run_update_text").innerHTML = '<i class="fa fa-exclamation-triangle"></i> Nyquist System Software update failed.';
				document.getElementById('okButton2').style.visibility='visible';
			}
		}
	}
	xmlhttp.open("GET","/system/run_system_update/"+filename_before_update,true);
	xmlhttp.send();
}
function startTimer() {
	timerInterval = setInterval(timerLoop, 1000);
}
function timerLoop(){
	
	minutes = parseInt(timer / 60, 10);
    seconds = parseInt(timer % 60, 10);

    minutes = minutes < 10 ? "0" + minutes : minutes;
    seconds = seconds < 10 ? "0" + seconds : seconds;

    document.getElementById("timer_text").innerHTML = minutes + ":" + seconds;
	
	--timer;
    
    if(timer==0){
		clearInterval(timerInterval);
       document.getElementById("run_update_text").innerHTML = '<div class="alert alert-success" role="alert"><strong><i class="fa fa-check-circle margin-bottom"></i>&nbsp;&nbsp;Nyquist system update completed. Please check the Nyquist dashboard for a confirmation message before restarting the Nyquist server.</strong></div>';
       document.getElementById('okButton2').style.visibility='visible';
    }
}
</script>
@endsection

